## ros-crystal-image-publisher 2.0.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(image_publisher)

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

find_package(ament_cmake REQUIRED)
find_package(cv_bridge REQUIRED)
find_package(camera_info_manager REQUIRED)
find_package(image_transport REQUIRED)
find_package(class_loader REQUIRED)
find_package(rclcpp REQUIRED)

set(opencv_2_components core highgui)
set(opencv_3_components core imgcodecs videoio)
find_package(OpenCV REQUIRED COMPONENTS core)
message(STATUS "opencv version ${OpenCV_VERSION}")
if(OpenCV_VERSION VERSION_LESS "3.0.0")
  find_package(OpenCV 2 REQUIRED COMPONENTS ${opencv_2_components})
else()
  find_package(OpenCV 3 REQUIRED COMPONENTS ${opencv_3_components})
endif()

include_directories(include)

add_library(image_publisher_node SHARED src/nodelet/image_publisher_nodelet.cpp)
target_link_libraries(image_publisher_node ${ament_LIBRARIES} ${OpenCV_LIBRARIES})
ament_target_dependencies(image_publisher_node
  "image_transport"
  "image_geometry"
  "cv_bridge"
  "class_loader"
  "camera_info_manager"
  "rclcpp"
)

rclcpp_register_node_plugins(image_publisher_node "${PROJECT_NAME}::ImagePublisherNode")
set(node_plugins "${node_plugins}${PROJECT_NAME}::ImagePublisherNode;$<TARGET_FILE:ImagePublisherNode>\n")

install(DIRECTORY include/${PROJECT_NAME}/
    DESTINATION include/${PROJECT_NAME}
    FILES_MATCHING PATTERN "*.h")

install(TARGETS image_publisher_node
        DESTINATION lib
)

add_executable(image_publisher src/node/image_publisher.cpp)
target_link_libraries(image_publisher ${ament_LIBRARIES} image_publisher_node)
ament_target_dependencies(image_publisher
  "rclcpp")

install(TARGETS image_publisher
        DESTINATION lib/${PROJECT_NAME}
)
install(TARGETS image_publisher
        DESTINATION bin
)

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  ament_lint_auto_find_test_dependencies()
endif()

ament_package()

=== debian/changelog ===
ros-crystal-image-publisher (2.0.0-0bionic) bionic; urgency=high

  * port image_publisher on ROS2 (#366 <https://github.com/ros-perception/image_pipeline/issues/366>)
    * port image_publisher on ROS2
    * switch to use cmake 3.5
    * change nodelet to classloader
    * change ros::param to ros2 parameter APIs
    * use ros2 code style
    * enable ros2 camera_info_manager
  * Initial ROS2 commit.
  * Contributors: Chris Ye, Michael Carroll

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Sun, 09 Dec 2018 06:00:00 -0000

ros-crystal-image-publisher (1.12.23-0bionic) bionic; urgency=high

  * fix 'VideoCapture' undefined symbol error (#318 <https://github.com/ros-perception/image_pipeline/issues/318>)
    * fix 'VideoCapture' undefined symbol error
    The following error occured when trying to run image_publisher:
    [...]/devel/lib/image_publisher/image_publisher: symbol lookup error: [...]/devel/lib//libimage_publisher.so: undefined symbol: _ZN2cv12VideoCaptureC1Ev
    Probably, changes in cv_bridge reducing the OpenCV component dependencies led to the error. See
    https://github.com/ros-perception/vision_opencv/commit/8b5bbcbc1ce65734dc600695487909e0c67c1033
    This is fixed by manually finding OpenCV with the required components and adding the dependencies to the library, not just the node.
    * add image_publisher opencv 2 compatibility
  * Contributors: hannometer

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Thu, 10 May 2018 05:00:00 -0000

ros-crystal-image-publisher (1.12.22-0bionic) bionic; urgency=high



 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Fri, 08 Dec 2017 06:00:00 -0000

ros-crystal-image-publisher (1.12.21-0bionic) bionic; urgency=high



 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Sun, 05 Nov 2017 05:00:00 -0000

ros-crystal-image-publisher (1.12.20-0bionic) bionic; urgency=high

  * explicitly cast to std::vector<double> to make gcc6 happy
    With gcc6, compiling image_publisher fails with this error:
    ```
    /[...]/image_publisher/src/nodelet/image_publisher_nodelet.cpp: In member function 'virtual void image_publisher::ImagePublisherNodelet::onInit()':
    /[...]/image_publisher/src/nodelet/image_publisher_nodelet.cpp:180:43: error: ambiguous overload for 'operator=' (operand types are 'sensor_msgs::CameraInfo\_<std::allocator<void> >::_D_type {aka std::vector<double>}' and 'boost::assign_detail::generic_list<int>')
    camera_info\_.D = list_of(0)(0)(0)(0)(0);
    ```
    After adding an initial explicit type cast for the assignment,
    compiling fails further with:
    ```
    | /[...]/image_publisher/src/nodelet/image_publisher_nodelet.cpp: In member function 'virtual void image_publisher::ImagePublisherNodelet::onInit()':
    | /[...]/image_publisher/src/nodelet/image_publisher_nodelet.cpp:180:65: error: call of overloaded 'vector(boost::assign_detail::generic_list<int>&)' is ambiguous
    |      camera_info\_.D = std::vector<double> (list_of(0)(0)(0)(0)(0));
    ```
    Various sources on the internet [1, 2, 3] point to use the
    convert_to_container method; hence, this commit follows those
    suggestions and with that image_publisher compiles with gcc6.
    [1] http://stackoverflow.com/questions/16211410/ambiguity-when-using-boostassignlist-of-to-construct-a-stdvector
    [2] http://stackoverflow.com/questions/12352692/ambiguous-call-with-list-of-in-vs2010/12362548#12362548 <https://github.com/ambiguous-call-with-list-of-in-vs2010/12362548/issues/12362548>
    [3] http://stackoverflow.com/questions/13285272/using-boostassignlist-of?rq=1
    Signed-off-by: Lukas Bulwahn <mailto:lukas.bulwahn@oss.bmw-carit.de>
  * address gcc6 build error
    With gcc6, compiling fails with stdlib.h: No such file or directory,
    as including '-isystem /usr/include' breaks with gcc6, cf.,
    https://gcc.gnu.org/bugzilla/show_bug.cgi?id=70129.
    This commit addresses this issue for this package in the same way
    it was addressed in various other ROS packages. A list of related
    commits and pull requests is at:
    https://github.com/ros/rosdistro/issues/12783
    Signed-off-by: Lukas Bulwahn <mailto:lukas.bulwahn@oss.bmw-carit.de>
  * Contributors: Lukas Bulwahn

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Sun, 30 Apr 2017 05:00:00 -0000

ros-crystal-image-publisher (1.12.19-0bionic) bionic; urgency=high

  * add image_publisher
  * Contributors: Kei Okada
  * add image_publisher
  * Contributors: Kei Okada

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Sun, 24 Jul 2016 05:00:00 -0000

=== debian/control ===
Source: ros-crystal-image-publisher
Section: misc
Priority: extra
Maintainer: Vincent Rabaud <vincent.rabaud@gmail.com>
Build-Depends: debhelper (>= 9.0.0), ros-crystal-ament-cmake, ros-crystal-ament-cmake-gtest, ros-crystal-ament-lint-auto, ros-crystal-ament-lint-common, ros-crystal-camera-info-manager, ros-crystal-class-loader, ros-crystal-cv-bridge, ros-crystal-image-transport, ros-crystal-rclcpp, ros-crystal-ros-workspace
Homepage: http://ros.org/wiki/image_publisher
Standards-Version: 3.9.2

Package: ros-crystal-image-publisher
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-crystal-camera-info-manager, ros-crystal-class-loader, ros-crystal-cv-bridge, ros-crystal-image-transport, ros-crystal-rclcpp, ros-crystal-ros-workspace
Description: Contains a node publish an image stream from single image file or avi motion file.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/crystal/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/crystal/setup.sh" ]; then . "/opt/ros/crystal/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/crystal" \
		-DAMENT_PREFIX_PATH="/opt/ros/crystal"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/crystal/setup.sh" ]; then . "/opt/ros/crystal/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/crystal/setup.sh" ]; then . "/opt/ros/crystal/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/crystal/setup.sh" ]; then . "/opt/ros/crystal/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-crystal-image-publisher//opt/ros/crystal/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/crystal/setup.sh" ]; then . "/opt/ros/crystal/setup.sh"; fi && \
	dh_auto_install
